import org.apache.bsf.*;   // BSF support
import java.io.*;          // exception handling


/** Test Java program which demonstrates how easy it is to invoke Rexx via BSF.
 * @author   Rony G. Flatscher, 2001-04-27, 2007-09-10
 */
public class InvokeRexxFromJava {

  /** Running an in-line defined Rexx script. */
  public static void main (String[] args) throws IOException
  {
    try
    {
        // get a BSFManager instance
      BSFManager mgr  = new BSFManager ();

        // load the Rexx engine for this BSFManager instance
      BSFEngine  rexx = mgr.loadScriptingEngine("rexx");

        // a String that contains Rexx code (may be read from file)
      String     rexxCode = "SAY 'Rexx was here!'"; //

        // execute the Rexx script
      rexx.exec ("rexx", 0, 0, rexxCode);
    }
    catch (BSFException e)  // if something went wrong, show it
    {
      e.printStackTrace();  // show the strack trace
    }
  }
}
