import com.ibm.bsf.*;   // BSF support
// import org.apache.bsf.*;   // BSF support
import java.io.*;       // exception handling

/** Test Java program which demonstrates how easy it is to invoke Rexx via BSF.
 *
 * @author   Rony G. Flatscher, 2001-05-23
 */
public class TestRexxCall {

  /** Running an in-line defined Rexx script.
   */
  public static void main (String[] args) throws IOException {
    try {

      BSFManager mgr  = new BSFManager ();
      BSFEngine  rexx = mgr.loadScriptingEngine("rexx");

                // create Rexx code right here in Java (could be read from file as well)
      String     rexxCode =
                 " say 'this is Rexx code called from Java!'; say                               ;"+
                 " say 'received [' || arg() || '] arguments:'; say                             ;"+
                 " do  i=1 to arg()                                                             ;"+
                 "    say '   arg # [' || i || '], exists? [' || arg(i, 'E') || '], value: [' || "+
                 "            arg(i) || ']'                                                     ;"+
                 " end                                                                          ;"+
                 " return 'Verweile doch, Du bist so schn ... !)' /* to be returned to Java */ ;"
                 ;

      Object args4rexx[] = new Object[9];

      Object     a = new Object();      // a pure Java object
      String  [] b = {"eins", "zwei" }; // an array of String

      java.util.Vector vArgs = new java.util.Vector();  // Vector for arguments to be passed to Rexx

        // changed add() to addElement() for JRE 1.1.8, ---rgf, 2001-05-23
      vArgs.addElement( new String("an argument of type String"));     // arg # 1
      vArgs.addElement( new Integer(17) );                             // arg # 2
      vArgs.addElement( new Float(17.71f));                            // arg # 3
      vArgs.addElement( Float.class);                                  // arg # 4
      vArgs.addElement( a );                                           // arg # 5
      vArgs.addElement( a.getClass().getName() + '@' + Integer.toHexString(a.hashCode()));     // arg # 6
      vArgs.addElement(null);                                          // arg # 7
      vArgs.addElement(b);                                             // arg # 8
      vArgs.addElement(b.getClass().getName() + '@' + Integer.toHexString(b.hashCode()));      // arg # 9

                // invoke Rexx and retrieve its return value
      Object obj = rexx.apply (null, 0, 0, rexxCode, null, vArgs);

      System.err.println("\t---\nResult received from Rexx: [" + obj + "]");

    } catch (BSFException e) {
      e.printStackTrace();
    }

    // System.exit(0);   // JRE build 1.3.0-C seems *sometimes* to need this ?!?

  }
}

