-- 2006-07-11, ---rgf, test new getCell() and setCell()-enhancement

-- Retrieve the Desktop object, we need its XComponentLoader interface to load
-- a new document
oDesktop         = UNO.createDesktop()    -- get the UNO Desktop service object
xComponentLoader = oDesktop~XDesktop~XComponentLoader  -- get componentLoader

bTestABit=.false -- .true -- dump uno service objects, test for services and interface names

say uno.queryInterfaceObjectByName(oDesktop, "xdesktop")

/* open the blank *.sxw - file */
url = "private:factory/scalc"
xCalcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)

/* get first sheet in spreadsheet */
xSheet = xCalcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet


/* insert some text */
CALL UNO.setCell xSheet, 0, 0, "HelloWorld!"
CALL UNO.setCell xSheet, 0, 2, 123.4567890987

CALL UNO.setCell xSheet, "b2", "HelloWorld! at b2"
CALL UNO.setCell xSheet, "c3", 123.4567890987

CALL UNO.setCell xSheet, "b3", "=c3+a3"

c1=uno.getCell(xSheet, "c3")
say "c1="pp(c1) "c1~value="pp(c1~value)
-- say "c1~uno.getDefinition="ppd(c1~uno.getDefinition)
say "c1~uno.getProperties="ppd(c1~uno.getProperties)

 cct=bsf.wrapStaticFields("com.sun.star.table.CellContentType")

say "---"

aha=.uno_enum~new("com.sun.star.table.CellContentType")
say "aha="pp(aha)
say "aha - unoidl_name:      " pp(aha~unoidl_name)
say "aha - unoidl_definition:" ppd(aha~unoidl_definition)
say "aha - unoidl_typeName  :" ppd(aha~unoidl_typeName)
say "aha - unoidl_className :" ppd(aha~unoidl_className)
say "--"

do idx over aha
   e1=aha~entry(idx)
   say "e1="aha~index(e1) "??"
   say "     " "idx:" pp(idx) "aha~entry(idx):" pp(aha~entry(idx)) pp(aha~entry(idx)~class) pp(aha~entry(idx)~"=="~c2x)
end

say "now retrieving the first 3x3 cell-values with number co-ordinates:"
do i=0 to 2
   do k=0 to 2
      cell=uno.getCell(xSheet,i,k)
      cellType=cell~getType
      -- say pp(i","k)":" pp(cell~getFormula) pp(cell~getValue) pp(cell~getError) pp(cellType)
      -- say pp(i","k)":" pp(cell~getFormula) pp(cell~getValue) pp(cell~getError) pp(aha~index(cellType))
      -- say pp(i","k)":" pp(aha~index(cellType))~left(10) pp(cell~getFormula)~left(20) pp(cell~getValue)~left(20) pp(cell~getError)
      say pp(i","k)":" pp(aha[cellType])~left(10) pp(cell~getFormula)~left(20) pp(cell~getValue)~left(20) pp(cell~getError)

      -- say "at:" pp(aha~at(cellType)) "index:" pp(aha~index(cellType)) "=="pp(celltype~"=="~c2x)
   end
end

say "---   ---   ---"
say "now retrieving the first 3x3 cell-values with letter-number co-ordinates:"
cols="ABC"
do i=1 to length(cols)
   c=substr(cols,i,1)
   do k=1 to 3
      cell=uno.getCell(xsheet,c||k)
      cellType=cell~getType
      -- say pp(c||k)":" pp(cell~getFormula) pp(cell~getValue) pp(cell~getError) pp(cell~getType)
      -- say pp(c||k)":" pp(aha~index(cellType))~left(10) pp(cell~getFormula)~left(20) pp(cell~getValue)~left(20) pp(cell~getError)
      say pp(c||k)":" pp(aha~entry(cellType))~left(10) pp(cell~getFormula)~left(20) pp(cell~getValue)~left(20) pp(cell~getError)
      -- say "   --->" cct~at(cell~getType)
   end
end

if bTestABit=.true then
do
   call testXSheet xSheet
   call testXComponentLoader xComponentLoader
end

say "--- makearray:"
do idx over aha
   say "aha, idx="pp(idx)~left(15) "aha[idx]="aha[idx]
end

say "--- supplier:"
s=aha~supplier
do while s~available
   say "    index="pp(s~index)~left(15) "item="pp(s~item)
   s~next
end

say "---"
say "aha~value="pp(aha~value) "aha~1="pp(aha~1)
say copies("=", 50)

-- aha=.uno_constants~new("com.sun.star.embed.EmbedMisc")
aha=.uno_constants~new("com.sun.star.awt.VclWindowPeerAttribute")
say "--- makearray:"
do idx over aha
   say "aha, idx="pp(idx)~left(15) "aha[idx]="aha[idx]
end

say "--- supplier:"
numeric digits 20
s=aha~supplier
do while s~available
   dec=s~item
   if dec<0 then
      string=dec~d2x(20)~x2b
   else
      string=dec~d2x~x2b

   say "  index="pp(s~index)~left(15) "item="pp(s~item) formatBinary(string)
   s~next
end

say "---"
say "aha~hscroll="pp(aha~hscroll) "aha~1="pp(aha~256)
say "aha~def_no ="pp(aha~def_no) "aha['-2147483648']="pp(aha["-2147483648"]) -- or numeric digits 20

dec=aha~def_no+aha~hscroll
dec=aha~def_no+aha~vscroll
dec=aha~hscroll+aha~vscroll
dec=aha~hscroll+aha~center+aha~defButton+aha~yes_no_cancel+aha~def_yes
string=dec~d2x(20)~x2b

say
say "---> dec="pp(dec) formatBinary(string)
tmp1=aha~decode(dec)
tmp2=aha~encode(tmp1)
say "     aha~decode("dec"):" pp(tmp1)
say "     aha~encode("tmp1"):" pp(tmp2)

say "aha...enumDir:"
trace ?i

say copies("=", 50)



::requires UNO.CLS    -- get UNO support

::routine formatBinary
  parse arg string

  bDash=.true
  do i=length(string)-4 to 1 by -4
     if bDash then
     do
        string=string~insert("-", i)
        bDash=.false
     end
     else
     do
        string=string~insert(" ", i)
        bDash=.true
     end
  end
  return string



::routine testXSheet
   use arg xSheet

   say copies(">", 50)
   say "xSheet="ppd(xSheet~uno.getDefinition)
   say
   say "uno.getXTypeProviderTypeNames(xSheet):" ppd(uno.getXTypeProviderTypeNames(xSheet))
   say
   say "xSheet~uno.queryInterfaceName('XFormulaQuery'):" pp(xSheet~uno.queryInterfaceName('XFormulaQuery'))
   say
   say "xSheet~uno.queryServiceName('Scenario'):       " pp(xSheet~uno.queryServiceName('Scenario'))
   say
   say "xSheet~uno.queryInterfaceName('nixi'):" pp(xSheet~uno.queryInterfaceName('nixi'))
   say "xSheet~uno.queryServiceName('nixi'):  " pp(xSheet~uno.queryServiceName('nixi'))
   say "xSheet~uno.getTypeName:" pp(xSheet~uno.getTypeName)
   say copies("<", 50)


::routine testXComponentLoader
   use arg xComponentLoader

   say copies(">", 50)
   say "xComponentLoader="ppd(xComponentLoader~uno.getDefinition)
   say
   say "uno.getXTypeProviderTypeNames(xComponentLoader):" ppd(uno.getXTypeProviderTypeNames(xComponentLoader))
   say
   say "xComponentLoader~uno.queryInterfaceName('desktop'):" pp(xComponentLoader~uno.queryInterfaceName('desktop'))
   say
   say "xComponentLoader~uno.queryServiceName('desktop'):  " pp(xComponentLoader~uno.queryServiceName('desktop'))
   say
   say "xComponentLoader~uno.queryInterfaceName('nixi'):" pp(xComponentLoader~uno.queryInterfaceName('nixi'))
   say "xComponentLoader~uno.queryServiceName('nixi'):  " pp(xComponentLoader~uno.queryServiceName('nixi'))
   say "xComponentLoader~uno.getTypeName:" pp(xComponentLoader~uno.getTypeName)
   say copies("<", 50)
   return



